//======================================================================
// Forward declarations for functions that deal directly with the engine
//======================================================================

void		UTIL_ShowMenu( edict_t *pEdict, int slots, int displaytime, bool needmore, char *aMenuList );
void		UTIL_HudText( CBaseEntity *pEntity, const hudtextparms_t &textparms, const char *pMessage );
void		UTIL_EnableMenu( CBaseEntity *pPlayer, char *szMessage, unsigned short uSlotFlags );
void		UTIL_DisableMenu( CBaseEntity *pPlayer );

bool		UTIL_IsBuilt ( edict_t *pent );

int			UTIL_CountBuildingsTeam(const char *building, int team);
int			UTIL_CountBuildings( const char *building );
int			Q_strncasecmp ( const char *s1, const char *s2, int n );
int			Q_strcasecmp ( const char *s1, const char *s2 );

void		UTIL_MovePlayer( edict_t *pPlayer, Vector vecOrigin );
void		UTIL_ScreenFade( edict_t *pPlayer, Vector colour, int alpha, float duration, float holdtime, int flags );

bool		UTIL_VecBetween( const Vector& point, const Vector& bottomLeft, const Vector& topRight );
char		*UTIL_GetLocation ( Vector &origin );
char		*Q_strcasestr ( const char * s1, const char * s2 );

void		UTIL_LookupLocationTitle ( char *pszTitle );
float		UTIL_GetDistance( vec3_t OriginStart, vec3_t OriginEnd );

// Try to decrease the number of problems when "overloading" CBaseEntity
void		UTIL_PhaseUse( CBaseEntity *pActivator, CBaseEntity *pThis );
void		UTIL_MCUse( CBaseEntity *pActivator, CBaseEntity *pThis );